/*
  rdmnet/implementation.cpp

  Copyright (c) 2021 Kevin Matz (kevin.matz@gmail.com)

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

#include "implementation.h"

namespace RDMnet {

/**
 * @brief Implementation::Implementation
 * @param cid
 * @param uid
 */
Implementation::Implementation(UUID::uuid cid, RDM::UID uid)
  : ACN::RLP::Component(cid)
  , RDM::Responder(uid)
  , LLRP::Target()
{
  fctn_ = "OpenLCP RDMnet Implementation";

  RlpRegisterVector(VECTOR_ROOT_LLRP, std::bind(&Implementation::rlpLlrpReceiver,
                                                  this, std::placeholders::_1));
  RlpRegisterVector(VECTOR_ROOT_EPT, std::bind(&Implementation::rlpEptReceiver,
                                                  this, std::placeholders::_1));
}


/**
 * @brief Implementation::rlpLlrpReceiver
 * @param root
 */
void Implementation::rlpLlrpReceiver(ACN::PDU::Message<ACN::RLP::Pdu> root)
{
  // data segment will be a block of LLRP Pdu
  root->createDataBlock<LLRP::Pdu>();

  auto block = std::static_pointer_cast<ACN::PDU::Block<LLRP::Pdu>>(root->data());
  for(auto const &frame : *block->pdu)
    LLRP::Target::receiveLLRP(frame);
}


/**
 * @brief Implementation::rlpEptReceiver
 * @param root
 */
void Implementation::rlpEptReceiver(ACN::PDU::Message<ACN::RLP::Pdu> root)
{
  // data segment will be a block of EPT Pdu
  root->createDataBlock<EPT::Pdu>();

  auto block = std::static_pointer_cast<ACN::PDU::Block<EPT::Pdu>>(root->data());
  for(auto const &frame : *block->pdu)
    EPT::Client::receiveEPT(frame);
}


} // namespace RDMnet
